<template>
  <span class="gpa-group-tags" :class="$props.blocks ? 'gpa-group-tags--blocks' : ''">
    <span v-for="(percentage, group) in pairs" :key="group">
      <gpa-crop-rotation-group-tag :group="group" :percentage="percentage" />
    </span>
  </span>
</template>

<script>
import GpaCropRotationGroupTag from './GroupTag.vue'

/**
 * Displays a list of crop rotation groups
 *
 * @preset groups {"props": { "groups": ["leaf", "root"] } }
 * @preset groupsWithCounts {"props": { "groupsWithCounts": { "manure": 60, "legume": 40 } } }
 */
export default {
  name: 'GpaCropRotationGroupTags',
  components: { GpaCropRotationGroupTag },
  props: {
    /** Array of values in `leaf`, `legume`, `manure` and `root`. Overridden by `groupsWithCounts` prop. */
    groups: { required: false, type: Array, default: () => [] },
    /** Object of keys in `leaf`, `legume`, `manure` and `root`, and a value as percentage */
    groupsWithCounts: { required: false, type: Object, default: null },
    /** Whether to display the list inline or as blocks */
    blocks: { required: false, type: Boolean, default: false },
  },
  computed: {
    pairs () {
      if (this.$props.groupsWithCounts) return this.$props.groupsWithCounts

      const hash = {}
      this.$props.groups.forEach(g => { hash[g] = null })

      return hash
    },
  },
}
</script>

<style lang="scss" src="./GroupTags.scss" />
